' Verbs.VBS V1.01 (C) yoshioka.teruo@nifty.com 2006-04-10
' Verbs.VBS shows Verbs of extension or file type.
' Usage: Start Verbs.VBS [.extension|filetype]

Option Explicit
Const HKCR=&H80000000 
Dim wShell
Dim arg
Dim KeyExists

Set wShell=CreateObject("WScript.Shell")

If WScript.Arguments.Count Then
  For Each arg In WScript.Arguments
    GetObject("winmgmts:{impersonationLevel=impersonate}!root/default:StdRegProv").CheckAccess HKCR,arg,1,KeyExists
    If Not KeyExists Then If InStrRev(arg,".") Then arg=Mid(arg,InStrRev(arg,"."))
    EnumVerbs arg
  Next
Else
  Do
    arg=InputBox("Enter Extension or File Type Name",WScript.ScriptName,arg)
    If arg="" Then Exit Do
    EnumVerbs arg
  Loop
End If
WScript.Quit

Sub EnumVerbs(Extension)
Dim Verbs
Dim k
Dim Rows
Dim FileType
Dim PerceivedType
Dim DeafaultVerb

Rows=Array()
Push Rows,Join(Array(Extension,RegRead("HKCR\"&Extension&"\")),vbTab)
Verbs=EnumKey(HKCR,Extension&"\Shell")
If Not IsNull(Verbs) Then
  DeafaultVerb=RegRead("HKCR\"&Extension&"\Shell\")
  If Not IsEmpty(DeafaultVerb) Then
    Push Rows,Join(Array("@",DeafaultVerb),vbTab)
  End If
  For k=0 To UBound(Verbs)
    Verbs(k)=Array(Verbs(k),RegRead("HKCR\"&Extension&"\Shell\"&Verbs(k)&"\"),RegRead("HKCR\"&Extension&"\Shell\"&Verbs(k)&"\command\"))
    Push Rows,Join(Verbs(k),vbTab)
  Next
End If
Verbs=EnumKey(HKCR,Extension&"\ShellEx\ContextMenuHandlers")
If Not IsNull(Verbs) Then
  For k=0 To UBound(Verbs)
    Verbs(k)=Array(Verbs(k),RegRead("HKCR\"&Extension&"\ShellEx\ContextMenuHandlers\"&Verbs(k)&"\"))
    Push Rows,Join(Verbs(k),vbTab)
  Next
End If
If Left(Extension,1)="." Then
  FileType=RegRead("HKCR\"&Extension&"\")
  PerceivedType=RegRead("HKCR\"&Extension&"\PerceivedType")
  If FileType<>"" Then
    Push Rows,""
    Push Rows,Join(Array(FileType,RegRead("HKCR\"&FileType&"\")),vbTab)
    Verbs=EnumKey(HKCR,FileType&"\Shell")
    If Not IsNull(Verbs) Then
      DeafaultVerb=RegRead("HKCR\"&FileType&"\Shell\")
      If Not IsEmpty(DeafaultVerb) Then
        Push Rows,Join(Array("@",DeafaultVerb),vbTab)
      End If
      For k=0 To UBound(Verbs)
        Verbs(k)=Array(Verbs(k),RegRead("HKCR\"&FileType&"\Shell\"&Verbs(k)&"\"),RegRead("HKCR\"&FileType&"\Shell\"&Verbs(k)&"\command\"))
        Push Rows,Join(Verbs(k),vbTab)
      Next
    End If
    Verbs=EnumKey(HKCR,FileType&"\ShellEx\ContextMenuHandlers")
    If Not IsNull(Verbs) Then
      For k=0 To UBound(Verbs)
        Verbs(k)=Array(Verbs(k),RegRead("HKCR\"&FileType&"\ShellEx\ContextMenuHandlers\"&Verbs(k)&"\"))
        Push Rows,Join(Verbs(k),vbTab)
      Next
    End If
  End If

  If Not IsNull(EnumKey(HKCR,"SystemFileAssociations\"&Extension)) Then
    Push Rows,""
    Push Rows,"SystemFileAssociations\"&Extension
    Verbs=EnumKey(HKCR,"SystemFileAssociations\"&Extension&"\Shell")
    If Not IsNull(Verbs) Then
      For k=0 To UBound(Verbs)
        Verbs(k)=Array(Verbs(k),RegRead("HKCR\SystemFileAssociations\"&Extension&"\Shell\"&Verbs(k)&"\"),RegRead("HKCR\SystemFileAssociations\"&Extension&"\Shell\"&Verbs(k)&"\command\"))
        Push Rows,Join(Verbs(k),vbTab)
      Next
    End If
    Verbs=EnumKey(HKCR,"SystemFileAssociations\"&Extension&"\ShellEx\ContextMenuHandlers")
    If Not IsNull(Verbs) Then
      For k=0 To UBound(Verbs)
        Verbs(k)=Array(Verbs(k),RegRead("HKCR\SystemFileAssociations\"&Extension&"\ShellEx\ContextMenuHandlers\"&Verbs(k)&"\"))
        Push Rows,Join(Verbs(k),vbTab)
      Next
    End If
  End If

  If PerceivedType<>"" Then
    Push Rows,""
    Push Rows,Join(Array("PerceivedType",PerceivedType),vbTab)
    Verbs=EnumKey(HKCR,"SystemFileAssociations\"&PerceivedType&"\Shell")
    If Not IsNull(Verbs) Then
      For k=0 To UBound(Verbs)
        Verbs(k)=Array(Verbs(k),RegRead("HKCR\SystemFileAssociations\"&PerceivedType&"\Shell\"&Verbs(k)&"\"),RegRead("HKCR\SystemFileAssociations\"&PerceivedType&"\Shell\"&Verbs(k)&"\command\"))
        Push Rows,Join(Verbs(k),vbTab)
      Next
    End If
    Verbs=EnumKey(HKCR,"SystemFileAssociations\"&PerceivedType&"\ShellEx\ContextMenuHandlers")
    If Not IsNull(Verbs) Then
      For k=0 To UBound(Verbs)
        Verbs(k)=Array(Verbs(k),RegRead("HKCR\SystemFileAssociations\"&PerceivedType&"\ShellEx\ContextMenuHandlers\"&Verbs(k)&"\"))
        Push Rows,Join(Verbs(k),vbTab)
      Next
    End If
  End If

End If
WScript.Echo Join(Rows,vbLf) 
End Sub

Function EnumKey(Root,Key)
Dim SubKeys
GetObject("winmgmts:{impersonationLevel=impersonate}!root/default:StdRegProv").EnumKey Root,Key,SubKeys 
EnumKey=SubKeys
End Function

Function RegRead(KeyName)
On Error Resume Next
RegRead=wShell.RegRead(KeyName)
If Err And Err<>-2147024894 Then WScript.Echo Err,Err.Description
On Error Goto 0
End Function

Sub Push(Items,Item)
ReDim Preserve Items(UBound(Items)+1)
Items(UBound(Items))=Item
End Sub
